;----------------------------------------------------------------------------

;G-200P header

;----------------------------------------------------------------------------

;Constantes:

.equ	FCLK	= 16000000		;Fclk, Hz
.equ	TSYS	= 1000			;time base, uS
.equ	MAXWORD	= 0xFFFF
.equ	MAXBYTE	= 0xFF

.equ T1DIV = ((((FCLK/1000)*TSYS)/100)+5)/10	;CK/1

.if  T1DIV > MAXWORD
.error "out of range constant"
.endif

;----------------------------------------------------------------------------

;Port Definitions:

;----------------------------------------------------------------------------

;Port B:

.equ	DIRB	= 0b00101111		;Port B direction
.equ	PUPB	= 0b11111111		;Port B pull-ups
.equ	FS	= PB0			; FPGA IO
.equ	IO1	= PB1			; FPGA IO
.equ	nCONFIG	= PB2			; FPGA nCONFIG
.equ	DATAO	= PB3			; FPGA DATAO/IO
.equ	DATAI	= PB4			; FPGA IO
.equ	DCLK	= PB5			; FPGA DCLK/IO

.macro	Port_FS_0			;FS = 0
	cbi	PORTB,FS
.endm

.macro	Port_FS_1			;FS = 1
	sbi	PORTB,FS
.endm

.macro	Port_DATAO_0			;DATAO = 0
	cbi	PORTB,DATAO
.endm

.macro	Port_DATAO_1			;DATAO = 1
	sbi	PORTB,DATAO
.endm

.macro	Skip_if_DATAI_0			;skip if DATAI = 0
	sbic	PINB,DATAI
.endm

.macro	Port_nCONFIG_0			;nCONFIG = 0
	cbi	PORTB,nCONFIG
.endm

.macro	Port_nCONFIG_1			;nCONFIG = 1
	sbi	PORTB,nCONFIG
.endm

;----------------------------------------------------------------------------

;Port C:

.equ	DIRC	= 0b00000000		;Port C direction
.equ	PUPC	= 0b11111111		;Port C pull-ups
;.equ		= PC0			; not used
;.equ		= PC1			; not used
.equ	CONFD	= PC2			; FPGA CONF_DONE
.equ	nSTAT	= PC3			; FPGA nSTATUS
;.equ		= PC4			; not used
;.equ		= PC5			; not used

.macro	Skip_if_CONFD_0			;skip if CONFD = 0
	sbic	PINC,CONFD
.endm

.macro	Skip_if_nSTAT_1			;skip if nSTAT = 1
	sbis	PINC,nSTAT
.endm

;----------------------------------------------------------------------------

;Port D:

.equ	DIRD	= 0b10000110		;Port D direction
.equ	PUPD	= 0b01111111		;Port D pull-ups
.equ	RXD	= PD0			; port RXD
.equ	TXD	= PD1			; port TXD
.equ	DIR	= PD2			; port DIR
;.equ		= PD3			; not used
;.equ		= PD4			; not used
.equ	IO3	= PD5			; FPGA IO
.equ	IO4	= PD6			; FPGA IO
.equ	NCLR	= PD7			; FPGA IO


.macro	Port_NCLR_0			;NCLR = 0
	cbi	PORTD,NCLR
.endm

.macro	Port_NCLR_1			;NCLR = 1
	sbi	PORTD,NCLR
.endm

;----------------------------------------------------------------------------

;Global Register Variables:

;r0, r1 used with mul instruction

.def	temp	= r16			;temporary register temp
.def	tempL	= r17			;temporary register tempL
.def	tempM	= r18			;temporary register tempH
.def	tempN	= r19			;temporary register tempH
.def	tempH	= r20			;temporary register tempH
.def	Cnt	= r21			;temporary register Cnt
.def	CMD	= r22			;command code to execute

.def	Flags	= r25			;flags
 .equ	fUpd	= 0			;timer update flag

;r26,r27 used as X-register
;r28,r29 used as Y-register
;r30,r31 used as Z-register

;----------------------------------------------------------------------------
